//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers   1

//
//
//
//
//

extern int    BarsToDisplay   = 50;
extern int    BarsWidth       = 5;
extern color  ColorNeutral    = DarkGray;
extern color  ColorUp         = LimeGreen;
extern color  ColorDown       = PaleVioletRed;
extern color  ColorBorder     = Black;
extern int    BorderWidth     = 2;
extern string UniqueID        = "Volume bars 1";
extern bool   AlertsOn        = false;
extern bool   AlertsOnCurrent = false;
extern bool   AlertsMessage   = true;
extern bool   AlertsSound     = false;
extern bool   AlertsEmail     = false;

double volumes[];
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,volumes); SetIndexStyle(0,DRAW_NONE);
      BarsToDisplay = MathMax(BarsToDisplay,10);
      BarsWidth     = MathMax(BarsWidth,1);
      IndicatorShortName(UniqueID);
   return(0);
}

//
//
//
//
//

int deinit()
{
   int lookForLength=StringLen(UniqueID);
   for (int i=ObjectsTotal(); i>=0; i--)
   {
      string name = ObjectName(i);
         if (StringSubstr(name,0,lookForLength)==UniqueID) ObjectDelete(name);
   }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int window      = WindowFind(UniqueID);
   int displayBars = MathMin(BarsToDisplay,Bars/BarsWidth);
   
      //
      //
      //
      //
      //

      for(int i=0; i<displayBars; i++)
      {
         for(int k=0; k<BarsWidth; k++) volumes[i*BarsWidth+k] = Volume[i];
         
         string name = UniqueID+":fill:"+i;
         color  theColor = ColorNeutral;
               if (Volume[i]>Volume[i+1]) theColor = ColorUp;
               if (Volume[i]<Volume[i+1]) theColor = ColorDown;
 
 
               ObjectCreate(name,OBJ_RECTANGLE,window,0,0,0,0);
                  ObjectSet(name,OBJPROP_PRICE1,0);
                  ObjectSet(name,OBJPROP_PRICE1,Volume[i]);
                  ObjectSet(name,OBJPROP_TIME1 ,Time[i*BarsWidth]);
                  ObjectSet(name,OBJPROP_TIME2 ,Time[i*BarsWidth+BarsWidth-1]);
                  ObjectSet(name,OBJPROP_COLOR,theColor);
                  ObjectSet(name,OBJPROP_BACK,true);
                  
         //
         //
         //
         //
         //
                           
         name = UniqueID+":fill:"+i+"rect";
               ObjectCreate(name,OBJ_RECTANGLE,window,0,0,0,0);
                  ObjectSet(name,OBJPROP_PRICE1,0);
                  ObjectSet(name,OBJPROP_PRICE1,Volume[i]);
                  ObjectSet(name,OBJPROP_TIME1 ,Time[i*BarsWidth]);
                  ObjectSet(name,OBJPROP_TIME2 ,Time[i*BarsWidth+BarsWidth-1]);
                  ObjectSet(name,OBJPROP_WIDTH,BorderWidth);
                  ObjectSet(name,OBJPROP_BACK,false);
                  if (BarsWidth==1)
                        ObjectSet(name,OBJPROP_COLOR,theColor);
                  else  ObjectSet(name,OBJPROP_COLOR,ColorBorder);
      }
      
      //
      //
      //
      //
      //
      
      if (AlertsOn)
      {
         int from=1; if (AlertsOnCurrent) from=0;
            if (Volume[from+0]>Volume[from+1] && Volume[from+1]>Volume[from+2] && Volume[from+2]>Volume[from+3]) doAlert(" 3 volumes rising up");
            if (Volume[from+0]<Volume[from+1] && Volume[from+1]<Volume[from+2] && Volume[from+2]<Volume[from+3]) doAlert(" 3 volumes falling down");
      }
      return(0);
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string previousAlert="";
   string message;

   if (previousAlert != doWhat) {
       previousAlert  = doWhat;

       //
       //
       //
       //
       //

       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
          if (AlertsMessage) Alert(message);
          if (AlertsEmail)   SendMail(Symbol()+" volumes",message);
          if (AlertsSound)   PlaySound("alert2.wav");
   }
}